/*******************************************************************************
 * Copyright (c) 2008 IGA Tosiki, NTT DATA BUSINESS BRAINS Corp.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IGA Tosiki (NTT DATA BUSINESS BRAINS Corp.) - initial API and implementation
 *******************************************************************************/
/*
 * blanco Framework
 * Copyright (C) 2008 NTT DATA BUSINESS BRAINS CORPORATION
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.nlpack.generator;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

import blanco.commons.util.BlancoStreamUtil;
import blanco.nlpack.generator.resourcebundle.BlancoNLpackGeneratorResourceBundle;
import blanco.nlpack.generator.valueobject.BlancoNLpackGeneratorManifest;

/**
 * blancoNLpackGeneratorで内部的に利用するユーティリティクラス。
 * 
 * @author IGA Tosiki
 */
public class BlancoNLpackGeneratorUtil {
    private static final BlancoNLpackGeneratorResourceBundle fBundle = new BlancoNLpackGeneratorResourceBundle();

    /**
     * プラグイン名に .nlja と バージョン番号を付与した名称を取得します。
     * 
     * @param manifest
     *            マニフェスト。
     * @return サフィックス付きプラグイン名。
     */
    public static String getPluginNameWithSuffix(
            final BlancoNLpackGeneratorManifest manifest) {
        return manifest.getBundleSymbolicName() + "."
                + fBundle.getSymbolicNameSuffix() + "_"
                + manifest.getBundleVersion();
    }

    /**
     * プラグインのフル名称からシンボリック名を類推します。
     * 
     * @param pluginFullName
     *            プラグインのフル名称。
     * @return シンボリック名。
     */
    public static String getBundleSymbolicName(final String pluginFullName) {
        // ポイント。アンダーバーで分割。
        final int underLine = pluginFullName.indexOf('_');
        if (underLine < 0) {
            throw new IllegalArgumentException("処理不能: getBundleSymbolicName("
                    + pluginFullName + ")");
        }
        return pluginFullName.substring(0, underLine);
    }

    /**
     * プラグインのフル名称からバージョンを類推します。
     * 
     * @param pluginFullName
     *            プラグインのフル名称。
     * @return バージョン。
     */
    public static String getBundleVersion(final String pluginFullName) {
        // ポイント。アンダーバーで分割。
        final int underLine = pluginFullName.indexOf('_');
        if (underLine < 0) {
            throw new IllegalArgumentException("処理不能: getBundleVersion("
                    + pluginFullName + ")");
        }
        return pluginFullName.substring(underLine + 1);
    }

    /**
     * マニフェストから URIを生成します。
     * 
     * @param manifest
     *            マニフェスト。
     * @param strPropertyFilePath
     *            プロパティファイルのパス。(マニフェストから決定できない場合に利用する)
     * @return URI。
     * @throws IOException
     *             入出力例外が発生した場合。
     */
    public static String getBabelURI(BlancoNLpackGeneratorManifest manifest,
            final String strPropertyFilePath) throws IOException {
        // TODO バージョンを埋め込むなどの考察。
        // 例: babel://シンボル名:バージョン/プロパティファイルのパス
        return "babel://" + manifest.getBundleSymbolicName() + "/"
                + strPropertyFilePath;
    }

    /**
     * 入力ストリームを全て読み込んでバイト配列化します。
     * 
     * @param inStream
     *            入力ストリーム。
     * @return バイト配列化された全データ。
     * @throws IOException
     *             入出力例外が発生した場合。
     */
    public static byte[] readBytes(final InputStream inStream)
            throws IOException {
        final ByteArrayOutputStream outStream = new ByteArrayOutputStream();
        BlancoStreamUtil.copy(inStream, outStream);
        outStream.flush();
        outStream.close();
        return outStream.toByteArray();
    }
}
